/*****************************************************
Chip type           : ATmega2560
Program type        : Application
Clock frequency     : 3,686000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 2048
*****************************************************/
#include <mega2560.h>
#include <KEY.h>

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
// Ports initialization
PORTE=0x00;
DDRE=0x40;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

init_KEY(); //  

SMCR=0x05;      // Sleep mode
#asm("sei")     // Global enable interrupts
#asm("sleep")   // Sleep

PORTE=0x40;

while (1)
      {

      };
}